
#include <Array.au3>
#include <Process.au3>
#include <File.au3>

;Dim $showline[5]
Dim $s_active[1000]
Dim $s_title[1000]
Dim $s_genre[1000]
Dim $s_fname[1000]
Dim $s_eplist[1000]
Dim $s_season[1000]
Dim $s_episode[1000]

;============================================================================================
; Hide the Tray Icon
;============================================================================================
TraySetState(@SW_HIDE)

$torrentpath = "./torrents"


;if FileExists( "MiniNova.ini" ) = 0 then Exit
if FileExists( "MiniNova.ini" ) = 0 then Exit
if FileExists( $torrentpath ) = 0 then DirCreate($torrentpath)
$s_fname = IniReadSectionNames( "MiniNova.ini" )

;============================================================================================
; Populate the Shows List
;============================================================================================

for $x = 1 to $s_fname[0]
	$s_active[$x] = Number( IniRead( "MiniNova.ini" , $s_fname[$x] , "active" , "0" ) )
	$s_title[$x] = IniRead( "MiniNova.ini" , $s_fname[$x] , "title" , "" )
	$s_genre[$x] = IniRead( "MiniNova.ini" , $s_fname[$x] , "genre" , "" )
	$s_eplist[$x] = IniRead( "MiniNova.ini" , $s_fname[$x] , "eplist" , "" )
	$s_season[$x] = IniRead( "MiniNova.ini" , $s_fname[$x] , "season" , "" )
	$s_episode[$x] = IniRead( "MiniNova.ini" , $s_fname[$x] , "episode" , "" )
next

;============================================================================================
; Download the RSS feed from Mininova
;============================================================================================

InetGet( "http://www.mininova.org/rss.xml?cat=8&num=99" , "rss.xml" , 1, 1)

$timerh = TimerInit()
while (@InetGetActive)
	if (TimerDiff($timerh)>6000) then 
		logout("ABORT - Download aborted... Download Timeout Exceeded")
		Exit
	endif
	$xfer = @InetGetBytesRead
	sleep(2000)
	if ($xfer = @InetGetBytesRead) then 
		logout("ABORT - Download aborted...  received " & $xfer & " bytes in " & TimerDiff($timerh) & " seconds")
		Exit
	endif
wend

if verifyrss("rss.xml") then
	logout("ABORT - RSS.XML could is not valid")
	Exit
else
	;logout("RSS.XML " & filegetsize("rss.xml") & " bytes received successfully")
endif

;============================================================================================
; Setup the MSXML Object 
;============================================================================================

$oXml = ObjCreate("Msxml2.DOMDocument.3.0")
$oXml.async=0
$oXml.Load("rss.xml")

$oXmlroot = $oXml.documentElement

;============================================================================================
; Weed out all of the nodes except Channel/Item
;============================================================================================

$oXmlnodes = $oXmlroot.selectNodes("channel/item")

;============================================================================================
; Check each Item against the Shows List
;============================================================================================

For $items In $oXmlnodes
		;====================================================================================
		; Pass the Node data to Variables
		;====================================================================================

		For $item In $items.childnodes
				Select
					Case $item.nodename = "title"
						$title = $item.text
						$epnum = ExtractEpisode( $title )
						$eptmp = stringsplit($epnum, "-")
						$season = number($eptmp[1])
						$episode = number($eptmp[2])
						;Msgbox( 0 , "Title" , $title & " [" & $epnum & "]")
						
					Case $item.nodename = "pubdate"
						$pubdate = $item.text
						;Msgbox( 0 , "pubDate:" , $pubdate )
					
					;Case $item.nodename = "category"
						;$category = $item.text
						;if ($category = "tv shows") then Msgbox( 0 , "Title" , $title & " [" & $epnum & "]")
		
					Case $item.nodename = "link"
						$link = stringreplace($item.text, "/tor/", "/get/")
						;Msgbox( 0 , "Link:" , $link )
				EndSelect
		next
		
		;============================================================================================
		; If the Title and Episode Data are a Match, then make it happen
		;============================================================================================
		
		$res = isMatch($title, $season, $episode)
		if $res then
			; Download the torrent
			$torrent = _TempFile($torrentpath, "Mininova_", ".torrent", 7)
			InetGet( $link , $torrent , 1 )
			; Update the INI file with the new episode info
			IniWrite( "MiniNova.ini" , $s_fname[$res] , "season" , $season )
			IniWrite( "MiniNova.ini" , $s_fname[$res] , "episode" , $episode )
			; Update the episode info in memory
			$s_season[$res] = $season
			$s_episode[$res] = $episode
			logout($s_fname[$res] & " - " & $season & "x" & $episode & " -- " & $title & " " & $pubdate)
			;msgbox(0, "", $title & @CRLF & $season & "x" & $episode & @CRLF & $pubdate & @crlf & $link)
		endif
next

;============================================================================================
Exit	
;============================================================================================


;============================================================================================
;	
;	Functions
;	
;============================================================================================

Func ExtractEpisode($input_line)
	
	Select
		;	##x## or #x## format
		case (stringregexp($input_line, "(\d\d[xX]\d\d)|(\d[xX]\d\d)|(\d\d[xX]\d)|(\d[xX]\d)"))
			$eptmp = stringregexp($input_line, "(\d\d[xX]\d\d)|(\d[xX]\d\d)|(\d\d[xX]\d)|(\d[xX]\d)", 1)
			$eptmp = number($eptmp[0]) & "-" & number(stringmid($eptmp[0], stringinstr($eptmp[0],"x")+1))
			;msgbox(0, "Match?", @error & @crlf & @extended & @crlf & $eptmp)
			return $eptmp
		
		;	s##e## or S##E## format
		case (stringregexp($input_line, "([sS]\d\d[eE]\d\d)|([sS]\d[eE]\d\d)|([sS]\d\d[eE]\d)|([sS]\d[eE]\d)"))
			$eptmp = stringregexp($input_line, "([sS]\d\d[eE]\d\d)|([sS]\d[eE]\d\d)|([sS]\d\d[eE]\d)|([sS]\d[eE]\d)", 1)
			$eptmp = number(stringmid($eptmp[0],2)) & "-" & number(stringmid($eptmp[0], stringinstr($eptmp[0],"e")+1))
			;msgbox(0, "Match?", @error & @crlf & @extended & @crlf & $eptmp)
			return $eptmp
			
		case else
			return "0-0"
	EndSelect

EndFunc

;============================================================================================

Func isMatch($input_line, $es, $en)
	
	if (($es + $en) = 0) then return 0
	
	$input_line = stringlower($input_line)
	for $x = 1 to $s_fname[0]
		if $s_active[$x] then
			$res = stringregexp($input_line, $s_title[$x], 3)
			; Did we find a title match?
			if @Extended then
				; Is $res an Array?
				if UBound($res) then
					select
						case ($res[0] = 0) and (($s_season[$x] < $es) or (($s_season[$x] = $es) and ($s_episode[$x] < $en)))
							return $x
						case (stringleft($s_title[$x], 2) <> "\#") and ($res[0] <> "") and (($s_season[$x] < $es) or (($s_season[$x] = $es) and ($s_episode[$x] < $en)))
							return $x
					endselect
				endif
			endif
		endif
	next
	
	return 0

EndFunc


;============================================================================================

Func logout($output)
	
	$output = @year & "-" & @mon & "-"& @mday & " -- " & $output
	filewriteline("Mininova.log", $output)

EndFunc

;============================================================================================

Func verifyrss($rssfn)
	
	$rsslen = filegetsize($rssfn)
	$rssdata = fileread($rssfn, $rsslen)
	if (stringinstr($rssdata, "<rss") > 0 and stringinstr($rssdata, "</rss>") > 0) then
		;msgbox(0, "", "rss good")
		return 0
	else
		;msgbox(0, "", "rss bad")
		return 1
	endif

EndFunc